## k3d 0.8.0.3

=== CMakeLists.txt ===
PROJECT(k3d)

# Configure CMake ...
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.1 FATAL_ERROR)
CMAKE_POLICY(SET CMP0003 OLD)

SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules")
SET(CMAKE_INSTALL_NAME_DIR "@exectuable_path/../lib/")

INCLUDE(K3DOutOfSourceBuild) # Disallow in-source builds
INCLUDE(K3DCompileResource)
INCLUDE(K3DGenerateDEF) # Convenience macro for linking Win32 DLLs using MSVC
INCLUDE(K3DDependencies)
INCLUDE(K3DWordSize) # Detect 32/64 bit platform
INCLUDE(K3DCompiler) # Detect problematic compilers

# Set the K-3D version
SET(K3D_MAJOR_VERSION 0)
SET(K3D_MINOR_VERSION 8)
SET(K3D_RELEASE_VERSION 0)
SET(K3D_BUILD_VERSION 3)
SET(K3D_SO_VERSION 1)

SET(K3D_PACKAGE k3d)
SET(K3D_VERSION ${K3D_MAJOR_VERSION}.${K3D_MINOR_VERSION}.${K3D_RELEASE_VERSION}.${K3D_BUILD_VERSION})
SET(K3D_HOST ${CMAKE_SYSTEM} ${CMAKE_SYSTEM_PROCESSOR})
SET(K3D_COPYRIGHT "Copyright (c) 1995-2010, Timothy M. Shead.	All Rights Reserved.")

# Run tests to find external packages ...
INCLUDE(K3DFind3ds)
INCLUDE(K3DFindCairomm)
INCLUDE(K3DFindCARVE)
INCLUDE(K3DFindCGAL)
INCLUDE(K3DFindCollada)
INCLUDE(K3DFindDBus)
INCLUDE(K3DFindFreetype2)
INCLUDE(K3DFindFTGL)
INCLUDE(K3DFindGlibmm)
INCLUDE(K3DFindGMM)
INCLUDE(K3DFindGnomeVFS)
INCLUDE(K3DFindGooglePerftools)
INCLUDE(K3DFindGtkGLExt)
INCLUDE(K3DFindGtkmm)
INCLUDE(K3DFindGtkSourceView)
INCLUDE(K3DFindGTS)
INCLUDE(K3DFindImageMagick)
INCLUDE(K3DFindInotify)
INCLUDE(K3DFindIntl)
INCLUDE(K3DFindJPEG)
INCLUDE(K3DFindODE)
INCLUDE(K3DFindOpenCascade)
INCLUDE(K3DFindOpenEXR)
INCLUDE(K3DFindOpenGL)
INCLUDE(K3DFindOSMesa)
INCLUDE(K3DFindPNG)
INCLUDE(K3DFindPython)
INCLUDE(K3DFindSigC)
INCLUDE(K3DFindSuperLU)
INCLUDE(K3DFindTBB)
INCLUDE(K3DFindTIFF)
INCLUDE(K3DFindXML)
INCLUDE(K3DFindZlib)

FIND_PACKAGE(Aqsis NO_MODULE QUIET)
FIND_PACKAGE(Qt4 4.6.2 COMPONENTS QtCore QtGui QtScript)
FIND_PACKAGE(K3DAsciiDoc)

# Setup platform-specific defaults ...
IF(WIN32 AND MSVC)
	SET(K3D_ENABLE_SYMBOL_VISIBILITY_DEFAULT ON)
ELSE()
	SET(K3D_ENABLE_SYMBOL_VISIBILITY_DEFAULT OFF)
ENDIF()

IF(Aqsis_FOUND AND QT4_FOUND)
	SET(K3D_QT_AQSIS_FOUND TRUE)
ELSE()
	SET(K3D_QT_AQSIS_FOUND FALSE)
ENDIF()

IF(K3D_OSMESA_FOUND AND QT4_FOUND)
	SET(K3D_QT_OSMESA_FOUND TRUE)
ELSE()
	SET(K3D_QT_OSMESA_FOUND FALSE)
ENDIF()

OPTION(K3D_BUILD_3DS_IO_MODULE "Build the 3ds_io module" ${K3D_3DS_FOUND})
OPTION(K3D_BUILD_ADVANCED_OPENGL_PAINTERS_MODULE "Build the advanced OpenGL mesh painters module" ON)
OPTION(K3D_BUILD_ANIMATION_MODULE "Build the animation module" ON)
OPTION(K3D_BUILD_ANNOTATION_MODULE "Build the annotation module" ${K3D_FREETYPE2_FOUND})
OPTION(K3D_BUILD_AQSIS_MODULE "Build the embedded Aqsis render engine module" ${Aqsis_FOUND})
OPTION(K3D_BUILD_ARRAY_MODULE "Build the array module" ON)
OPTION(K3D_BUILD_BICUBIC_PATCH_MODULE "Build the bicubic patch module" ON)
OPTION(K3D_BUILD_BILINEAR_PATCH_MODULE "Build the bilinear patch module" ON)
OPTION(K3D_BUILD_BITMAP_MODULE "Build the bitmap module" ON)
OPTION(K3D_BUILD_BLOBBY_MODULE "Build the blobby module" ON)
OPTION(K3D_BUILD_BUNDLED_RENDERMAN_ENGINES_MODULE "Provides integration with RenderMan-compatible render engines that are bundled with K-3D." OFF)
OPTION(K3D_BUILD_CARVE_MODULE "Build the CARVE module" ${K3D_CARVE_FOUND})
OPTION(K3D_BUILD_CGAL_MODULE "Build the CGAL module" ${K3D_CGAL_FOUND})
OPTION(K3D_BUILD_CLOTH_MODULE "Build the cloth module" ON)
OPTION(K3D_BUILD_COLLADA_IO_MODULE "Build the COLLADA module" ${K3D_COLLADA_FOUND})
OPTION(K3D_BUILD_COMPIZ_MODULE "Build the Compiz module" ${K3D_DBUS_FOUND})
OPTION(K3D_BUILD_CORE_MODULE "Build the core module" ON)
OPTION(K3D_BUILD_CUDA_MODULE "Build the cuda module" OFF)
OPTION(K3D_BUILD_DEFORMATION_MODULE "Build the mesh deformation module" ON)
OPTION(K3D_BUILD_DEVELOPMENT_MODULE "Build the development module" ON)
OPTION(K3D_BUILD_DOUBLE_MODULE "Build the double module" ON)
OPTION(K3D_BUILD_EULER_OPERATIONS_MODULE "Build the module that exposes the Euler mesh operations as mesh modifiers" OFF)
OPTION(K3D_BUILD_FILE_MAGIC_MODULE "Build the file-identification-magic module" ON)
OPTION(K3D_BUILD_FREETYPE2_MODULE "Build the freetype2 module" ON)
OPTION(K3D_BUILD_GLX_MODULE "Build the GLX offscreen rendering module" OFF)
OPTION(K3D_BUILD_GNOME_MODULE "Build the GNOME integration module" ${K3D_GNOME_VFS_FOUND})
OPTION(K3D_BUILD_GOOGLE_PERFTOOLS_MODULE "Build the Google Perftools profiling module" ${K3D_GOOGLE_PERFTOOLS_FOUND})
OPTION(K3D_BUILD_GRAPHVIZ_MODULE "Build the GraphViz integration module" ON)
OPTION(K3D_BUILD_GTS_IO_MODULE "Build the GNU Triangulated Surfaces file format module" ON)
OPTION(K3D_BUILD_GTS_MODULE "Build the GNU Triangulated Surfaces module" ${K3D_GTS_FOUND})
OPTION(K3D_BUILD_HIGHLIGHTING_MODULE "Build the user interface 'highlighting' module" ON)
OPTION(K3D_BUILD_IGES_IO_MODULE "Build the IGES file format module" ON)
OPTION(K3D_BUILD_IMAGEMAGICK_IO_MODULE "Build the ImageMagick file format module" ${K3D_IMAGEMAGICK_FOUND})
OPTION(K3D_BUILD_INDIGO_MODULE "Build the Indigo render engine integration module" ON)
OPTION(K3D_BUILD_INOTIFY_MODULE "Build the inotify file change notification module" ${K3D_INOTIFY_FOUND})
OPTION(K3D_BUILD_JPEG_IO_MODULE "Build the jpeg file format module" ${K3D_JPEG_FOUND})
OPTION(K3D_BUILD_K3D_IO_MODULE "Build the K-3D file format module" ON)
OPTION(K3D_BUILD_LINEAR_CURVE_MODULE "Build the linear curve module" ON)
OPTION(K3D_BUILD_LIPSYNC_MODULE "Build the lip synchronization tools module" ON)
OPTION(K3D_BUILD_LSYSTEM_MODULE "Build the l-system parser module" ON)
OPTION(K3D_BUILD_LUXRENDER_MODULE "Build the Luxrender render enegine integration module" ON)
OPTION(K3D_BUILD_MATRIX_MODULE "Build the matrix operations module" ON)
OPTION(K3D_BUILD_MD2_IO_MODULE "Build the md2 io module" ON)
OPTION(K3D_BUILD_MESH_ATTRIBUTES_MODULE "Build the mesh attributes module" ON)
OPTION(K3D_BUILD_MESH_INSTANCE_MODULE "Build the mesh-instance module" ON)
OPTION(K3D_BUILD_MESH_MODULE "Build the mesh module" ON)
OPTION(K3D_BUILD_NGUI_ABOUT_MODULE "Build the user interface 'about' dialog module" ON)
OPTION(K3D_BUILD_NGUI_ANIMATION_TIMELINE_PANEL_MODULE "Build the experimental animation timeline panel module" ON)
OPTION(K3D_BUILD_NGUI_ASSIGN_HOTKEYS_MODULE "Build the user interface 'assign hotkeys' module" ON)
OPTION(K3D_BUILD_NGUI_ATK_EVENT_RECORDER_MODULE "Build the user interface ATK 'event recorder' module" OFF)
OPTION(K3D_BUILD_NGUI_KNOT_VECTOR_CONTROL_MODULE "Build the custom knot-vector property control module" ON)
OPTION(K3D_BUILD_NGUI_LEARNING_MODULE "Build the user interface learning (tutorial) dialog module" ON)
OPTION(K3D_BUILD_NGUI_LOG_MODULE "Build the user interface log window module" ON)
OPTION(K3D_BUILD_NGUI_MATERIAL_MANAGER_PANEL_MODULE "Build the user interface manager manager panel module" OFF)
OPTION(K3D_BUILD_NGUI_MESH_CONTROL_MODULE "Build the mesh property control module" ON)
OPTION(K3D_BUILD_NGUI_MODULE "Build the standard graphical user interface module" ON)
OPTION(K3D_BUILD_NGUI_MORPH_POINTS_PAGE_MODULE "Build the MorphPoints custom property page module" ON)
OPTION(K3D_BUILD_NGUI_NODE_LIST_PANEL_MODULE "Build the user interface node list panel module" ON)
OPTION(K3D_BUILD_NGUI_NODE_PROPERTIES_PANEL_MODULE "Build the user interface node properties panel module" ON)
OPTION(K3D_BUILD_NGUI_OPENGL_DIALOG_MODULE "Build the user interface OpenGL information dialog module" ON)
OPTION(K3D_BUILD_NGUI_PARENT_TOOL_MODULE "Build the user interface 'parent tool' module" ON)
OPTION(K3D_BUILD_NGUI_PIPELINE_PANEL_MODULE "Build the user interface pipeline display panel module" ON)
OPTION(K3D_BUILD_NGUI_PIPELINE_PROFILER_PANEL_MODULE "Build the user interface pipeline profiler panel module" ON)
OPTION(K3D_BUILD_NGUI_PYTHON_SHELL_MODULE "Build the interactive Python shell module" ON)
OPTION(K3D_BUILD_NGUI_RECTANGLE_CONTROL_MODULE "Build the custom rectangle property control module" ON)
OPTION(K3D_BUILD_NGUI_RENDER_REGION_TOOL_MODULE "Build the user interface 'render region tool' module" ON)
OPTION(K3D_BUILD_NGUI_SELECTION_CONTROL_MODULE "Build the selection property control module" ON)
OPTION(K3D_BUILD_NGUI_SNAP_TOOL_MODULE "Build the user interface 'snap tool' module" ON)
OPTION(K3D_BUILD_NGUI_SPACE_NAVIGATOR_MODULE "Build the SpaceNavigator 3D mouse integration module" OFF)
OPTION(K3D_BUILD_NGUI_TEXT_EDITOR_MODULE "Build the user interface text editor module" ON)
OPTION(K3D_BUILD_NGUI_TIMELINE_PANEL_MODULE "Build the user interface timeline panel module" ON)
OPTION(K3D_BUILD_NGUI_TOOLBAR_PANEL_MODULE "Build the user interface toolbar panel module" ON)
OPTION(K3D_BUILD_NGUI_TOOL_PROPERTIES_PANEL_MODULE "Build the user interface tool properties panel module" ON)
OPTION(K3D_BUILD_NGUI_UNDO_TREE_PANEL_MODULE "Build the user interface undo panel module" ON)
OPTION(K3D_BUILD_NGUI_UV_EDITOR_PANEL_MODULE "Build the user interface UV editor panel module" OFF)
OPTION(K3D_BUILD_NUI_MODULE "Build the Null User Interface module" ON)
OPTION(K3D_BUILD_NURBS_MODULE "Build the NURBS module" ON)
OPTION(K3D_BUILD_NURBS_SOURCES_MODULE "Build the NURBS sources module" ON)
OPTION(K3D_BUILD_OBJ_IO_MODULE "Build the Wavefront .obj file format module" ON)
OPTION(K3D_BUILD_ODE_MODULE "Build the Open Dynamics Engine (ODE) integration module" ${K3D_ODE_FOUND})
OPTION(K3D_BUILD_OGRE_IO_MODULE "Build the Object-oriented Graphics Engine (OGRE) file I/O module" ON)
OPTION(K3D_BUILD_OPENCASCADE_MODULE "Build the OpenCascade module" ${K3D_OPENCASCADE_FOUND})
OPTION(K3D_BUILD_OPENEXR_IO_MODULE "Build the OpenEXR file format module" ${K3D_OPENEXR_FOUND})
OPTION(K3D_BUILD_OPENGL_MODULE "Build the OpenGL integration module" ON)
OPTION(K3D_BUILD_OSMESA_MODULE "Build the Offscreen Mesa integration module" ${K3D_OSMESA_FOUND})
OPTION(K3D_BUILD_OSX_MODULE "Build the Mac OSX integration module" ${APPLE})
OPTION(K3D_BUILD_PARTICLE_MODULE "Build the point group module" ON)
OPTION(K3D_BUILD_PDIFF_MODULE "Build the perceptual-diff module" ON)
OPTION(K3D_BUILD_PIXIE_MODULE "Build the Pixie render engine integration module" ON)
OPTION(K3D_BUILD_PLOT_MODULE "Build the function-plot module" ON)
OPTION(K3D_BUILD_PLY_IO_MODULE "Build the Stanford .ply file format module" ON)
OPTION(K3D_BUILD_PNG_IO_MODULE "Build the PNG file format module" ON)
OPTION(K3D_BUILD_POLYHEDRON_MODULE "Build the polyhedron module" ON)
OPTION(K3D_BUILD_POLYHEDRON_SOURCES_MODULE "Build the polyhedron sources module" ON)
OPTION(K3D_BUILD_PYTHON_MODULE "Build the Python scripting language module" ON)
OPTION(K3D_BUILD_PYUI_MODULE "Build the Python user interface plugin" ON)
OPTION(K3D_BUILD_QSLIM_MODULE "Build the qslim module" ON)
OPTION(K3D_BUILD_QTUI_ABOUT_DIALOG_MODULE "Build the Qt user interface 'about' dialog module" OFF)
OPTION(K3D_BUILD_QTUI_AQSIS_MODE_MODULE "Build the Qt-Aqsis integration mode module" OFF)
OPTION(K3D_BUILD_QTUI_AQSIS_MODULE "Build the Qt-Aqsis integration module" OFF)
OPTION(K3D_BUILD_QTUI_BOOLEAN_MODULE "Build the Qt graphical user interface boolean property widget module" OFF)
OPTION(K3D_BUILD_QTUI_COLOR_MODULE "Build the Qt graphical user interface color property widget module" OFF)
OPTION(K3D_BUILD_QTUI_DEFAULT_MODE_MODULE "Build the Qt graphical user interface default mode module" OFF)
OPTION(K3D_BUILD_QTUI_JAVASCRIPT_SHELL_MODULE "Build the Qt graphical user interface interactive JavaScript shell module" OFF)
OPTION(K3D_BUILD_QTUI_LOG_MODULE "Build the Qt user interface log window module" OFF)
OPTION(K3D_BUILD_QTUI_MATRIX_MODULE "Build the Qt graphical user interface matrix property widget module" OFF)
OPTION(K3D_BUILD_QTUI_MODULE "Build the Qt graphical user interface module" OFF)
OPTION(K3D_BUILD_QTUI_MOVE_MODE_MODULE "Build the user interface mode to move components" OFF)
OPTION(K3D_BUILD_QTUI_NODE_LIST_MODULE "Build the Qt graphical user interface node list module" OFF)
OPTION(K3D_BUILD_QTUI_NODE_PROPERTIES_MODULE "Build the Qt graphical user interface node properties module" OFF)
OPTION(K3D_BUILD_QTUI_OPENGL_MODULE "Build the Qt graphical user interface OpenGL-test module" OFF)

=== bugs/CMakeLists.txt ===
PROJECT(ditz)

FIND_PROGRAM(DITZ_EXECUTABLE ditz)

ADD_CUSTOM_TARGET(bugs-html
	WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
	COMMAND ${DITZ_EXECUTABLE} html "${CMAKE_CURRENT_BINARY_DIR}/html"
	)

=== modules/CMakeLists.txt ===
SET(K3D_PLUGINS "" CACHE INTERNAL "" FORCE)

INCLUDE(K3DParseArguments)

MACRO(K3D_BUILD_MODULE MODULE_NAME)
	K3D_PARSE_ARGUMENTS(MODULE "EXTRA_SOURCES;EXCLUDE_SOURCES" "" ${ARGN})

	SET(K3D_PLUGINS ${K3D_PLUGINS} ${MODULE_NAME} CACHE INTERNAL "" FORCE)

	FILE(GLOB ABSOLUTE_HEADERS *.h)
	FILE(GLOB ABSOLUTE_SOURCES *.cpp)

	LIST(SORT ABSOLUTE_HEADERS)
	LIST(SORT ABSOLUTE_SOURCES)

	FOREACH(ABSOLUTE_HEADER ${ABSOLUTE_HEADERS})
		GET_FILENAME_COMPONENT(HEADER ${ABSOLUTE_HEADER} NAME)
		LIST(APPEND HEADERS ${HEADER})
	ENDFOREACH()

	FOREACH(ABSOLUTE_SOURCE ${ABSOLUTE_SOURCES})
		GET_FILENAME_COMPONENT(SOURCE ${ABSOLUTE_SOURCE} NAME)
		LIST(APPEND SOURCES ${SOURCE})
	ENDFOREACH()

	LIST(LENGTH HEADERS HEADER_COUNT)
	LIST(LENGTH SOURCES SOURCE_COUNT)

	IF(HEADER_COUNT GREATER 0)
		FOREACH(MODULE_EXCLUDE_SOURCE ${MODULE_EXCLUDE_SOURCES})
			LIST(REMOVE_ITEM HEADERS ${MODULE_EXCLUDE_SOURCE})
		ENDFOREACH()
	ENDIF()

	IF(SOURCE_COUNT GREATER 0)
		FOREACH(MODULE_EXCLUDE_SOURCE ${MODULE_EXCLUDE_SOURCES})
			LIST(REMOVE_ITEM SOURCES ${MODULE_EXCLUDE_SOURCE})
		ENDFOREACH()
	ENDIF()

	INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
	INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
	INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_OPENGL_INCLUDE_DIR})

	IF(K3D_ENABLE_NLS)
		INCLUDE_DIRECTORIES(${K3D_INTL_INCLUDE_DIRS})
	ENDIF(K3D_ENABLE_NLS)

	IF(K3D_ENABLE_PARALLEL)
		INCLUDE_DIRECTORIES(${K3D_TBB_INCLUDE_DIR})
	ENDIF(K3D_ENABLE_PARALLEL)

	IF(K3D_ENABLE_PROFILING)
		INCLUDE_DIRECTORIES(${K3D_GOOGLE_PERFTOOLS_INCLUDE_DIR})
	ENDIF(K3D_ENABLE_PROFILING)

	LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

	ADD_LIBRARY(${MODULE_NAME} MODULE ${HEADERS} ${SOURCES} ${MODULE_EXTRA_SOURCES})
	SET_TARGET_PROPERTIES(${MODULE_NAME} PROPERTIES
		LIBRARY_OUTPUT_DIRECTORY ${K3D_MODULE_OUTPUT_DIRECTORY}
		PREFIX ""
		SUFFIX ".module"
		)

	TARGET_LINK_LIBRARIES(${MODULE_NAME} k3dsdk)

	IF(K3D_ENABLE_NLS)
		TARGET_LINK_LIBRARIES(${MODULE_NAME} ${K3D_INTL_LIBS})
	ENDIF(K3D_ENABLE_NLS)

	IF(K3D_ENABLE_PROFILING)
		TARGET_LINK_LIBRARIES(${PLUGIN_NAME} ${K3D_PROFILER_LIBRARY})
	ENDIF(K3D_ENABLE_PROFILING)

	INSTALL(TARGETS ${MODULE_NAME}
		RUNTIME DESTINATION ${K3D_LIBDIR}/k3d/plugins
		LIBRARY DESTINATION ${K3D_LIBDIR}/k3d/plugins)
ENDMACRO(K3D_BUILD_MODULE)

MACRO(K3D_BUILD_NGUI_MODULE MODULE_NAME)
	INCLUDE_DIRECTORIES(${K3D_CAIROMM_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_GTKMM_INCLUDE_DIRS})
	INCLUDE_DIRECTORIES(${K3D_GTKGLEXT_INCLUDE_DIRS})

	LINK_DIRECTORIES(${K3D_GTKGLEXT_LIB_DIRS})

	K3D_BUILD_MODULE(${MODULE_NAME} ${ARGN})

	TARGET_LINK_LIBRARIES(${MODULE_NAME} k3dsdk-ngui)
	TARGET_LINK_LIBRARIES(${MODULE_NAME} ${K3D_CAIROMM_LIBS})
ENDMACRO(K3D_BUILD_NGUI_MODULE)

MACRO(K3D_BUILD_QTUI_MODULE MODULE_NAME)
	ADD_DEFINITIONS(-DQT_NO_KEYWORDS)

	INCLUDE_DIRECTORIES(${k3dsdk-qtui_BINARY_DIR})
	INCLUDE_DIRECTORIES(${QT_INCLUDES})

	K3D_BUILD_MODULE(${MODULE_NAME} ${ARGN})
	TARGET_LINK_LIBRARIES(${MODULE_NAME} k3dsdk-qtui)
ENDMACRO()

MACRO(K3D_CREATE_MODULE_PROXY MODULE_NAME)
	GET_TARGET_PROPERTY(K3D_MAKE_MODULE_PROXY k3d-make-module-proxy LOCATION)
	GET_TARGET_PROPERTY(MODULE ${MODULE_NAME} LOCATION)
	ADD_CUSTOM_COMMAND(
		OUTPUT ${MODULE}.proxy
		COMMAND ${K3D_MAKE_MODULE_PROXY} ${MODULE} ${MODULE}.proxy
		DEPENDS k3d-make-module-proxy ${MODULE_NAME}
		)
	ADD_CUSTOM_TARGET(${MODULE_NAME}-proxy ALL DEPENDS ${MODULE}.proxy)
	INSTALL(FILES ${MODULE}.proxy DESTINATION ${K3D_LIBDIR}/k3d/plugins)
ENDMACRO(K3D_CREATE_MODULE_PROXY)

K3D_ADD_SUBDIRECTORY(3ds_io REQUIRES K3D_BUILD_3DS_IO_MODULE)
K3D_ADD_SUBDIRECTORY(advanced_opengl_painters REQUIRES K3D_BUILD_ADVANCED_OPENGL_PAINTERS_MODULE)
K3D_ADD_SUBDIRECTORY(animation REQUIRES K3D_BUILD_ANIMATION_MODULE)
K3D_ADD_SUBDIRECTORY(annotation REQUIRES K3D_BUILD_ANNOTATION_MODULE)
K3D_ADD_SUBDIRECTORY(aqsis REQUIRES K3D_BUILD_AQSIS_MODULE)
K3D_ADD_SUBDIRECTORY(array REQUIRES K3D_BUILD_ARRAY_MODULE)
K3D_ADD_SUBDIRECTORY(bicubic_patch REQUIRES K3D_BUILD_BICUBIC_PATCH_MODULE)
K3D_ADD_SUBDIRECTORY(bilinear_patch REQUIRES K3D_BUILD_BILINEAR_PATCH_MODULE)
K3D_ADD_SUBDIRECTORY(bitmap REQUIRES K3D_BUILD_BITMAP_MODULE)
K3D_ADD_SUBDIRECTORY(blobby REQUIRES K3D_BUILD_BLOBBY_MODULE)
K3D_ADD_SUBDIRECTORY(bundled_renderman_engines REQUIRES K3D_BUILD_BUNDLED_RENDERMAN_ENGINES_MODULE)
K3D_ADD_SUBDIRECTORY(carve REQUIRES K3D_BUILD_CARVE_MODULE)
K3D_ADD_SUBDIRECTORY(cgal REQUIRES K3D_BUILD_CGAL_MODULE)
K3D_ADD_SUBDIRECTORY(cloth REQUIRES K3D_BUILD_CLOTH_MODULE)
K3D_ADD_SUBDIRECTORY(collada_io REQUIRES K3D_BUILD_COLLADA_IO_MODULE)
K3D_ADD_SUBDIRECTORY(compiz REQUIRES K3D_BUILD_COMPIZ_MODULE)
K3D_ADD_SUBDIRECTORY(core REQUIRES K3D_BUILD_CORE_MODULE)
K3D_ADD_SUBDIRECTORY(cuda REQUIRES K3D_BUILD_CUDA_MODULE)
K3D_ADD_SUBDIRECTORY(deformation REQUIRES K3D_BUILD_DEFORMATION_MODULE)
K3D_ADD_SUBDIRECTORY(development REQUIRES K3D_BUILD_DEVELOPMENT_MODULE)
K3D_ADD_SUBDIRECTORY(double REQUIRES K3D_BUILD_DOUBLE_MODULE)
K3D_ADD_SUBDIRECTORY(euler_operations REQUIRES K3D_BUILD_EULER_OPERATIONS_MODULE)
K3D_ADD_SUBDIRECTORY(file_magic REQUIRES K3D_BUILD_FILE_MAGIC_MODULE)
K3D_ADD_SUBDIRECTORY(freetype2 REQUIRES K3D_BUILD_FREETYPE2_MODULE)
K3D_ADD_SUBDIRECTORY(glx REQUIRES K3D_BUILD_GLX_MODULE)
K3D_ADD_SUBDIRECTORY(gnome REQUIRES K3D_BUILD_GNOME_MODULE)
K3D_ADD_SUBDIRECTORY(google_perftools REQUIRES K3D_BUILD_GOOGLE_PERFTOOLS_MODULE)
K3D_ADD_SUBDIRECTORY(graphviz REQUIRES K3D_BUILD_GRAPHVIZ_MODULE)
K3D_ADD_SUBDIRECTORY(gts_io REQUIRES K3D_BUILD_GTS_IO_MODULE)
K3D_ADD_SUBDIRECTORY(gts REQUIRES K3D_BUILD_GTS_MODULE)
K3D_ADD_SUBDIRECTORY(highlighting REQUIRES K3D_BUILD_HIGHLIGHTING_MODULE)
K3D_ADD_SUBDIRECTORY(iges_io REQUIRES K3D_BUILD_IGES_IO_MODULE)
K3D_ADD_SUBDIRECTORY(imagemagick_io REQUIRES K3D_BUILD_IMAGEMAGICK_IO_MODULE)
K3D_ADD_SUBDIRECTORY(indigo REQUIRES K3D_BUILD_INDIGO_MODULE)
K3D_ADD_SUBDIRECTORY(inotify REQUIRES K3D_BUILD_INOTIFY_MODULE)
K3D_ADD_SUBDIRECTORY(jpeg_io REQUIRES K3D_BUILD_JPEG_IO_MODULE)
K3D_ADD_SUBDIRECTORY(k3d_io REQUIRES K3D_BUILD_K3D_IO_MODULE)
K3D_ADD_SUBDIRECTORY(linear_curve REQUIRES K3D_BUILD_LINEAR_CURVE_MODULE)
K3D_ADD_SUBDIRECTORY(lipsync REQUIRES K3D_BUILD_LIPSYNC_MODULE)
K3D_ADD_SUBDIRECTORY(lsystem REQUIRES K3D_BUILD_LSYSTEM_MODULE)
K3D_ADD_SUBDIRECTORY(luxrender REQUIRES K3D_BUILD_LUXRENDER_MODULE)
K3D_ADD_SUBDIRECTORY(matrix REQUIRES K3D_BUILD_MATRIX_MODULE)
K3D_ADD_SUBDIRECTORY(md2_io REQUIRES K3D_BUILD_MD2_IO_MODULE)
K3D_ADD_SUBDIRECTORY(mesh_attributes REQUIRES K3D_BUILD_MESH_ATTRIBUTES_MODULE)
K3D_ADD_SUBDIRECTORY(mesh_instance REQUIRES K3D_BUILD_MESH_INSTANCE_MODULE)
K3D_ADD_SUBDIRECTORY(mesh REQUIRES K3D_BUILD_MESH_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_about REQUIRES K3D_BUILD_NGUI_ABOUT_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_animation_timeline_panel REQUIRES K3D_BUILD_NGUI_ANIMATION_TIMELINE_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_assign_hotkeys REQUIRES K3D_BUILD_NGUI_ASSIGN_HOTKEYS_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_atk_event_recorder REQUIRES K3D_BUILD_NGUI_ATK_EVENT_RECORDER_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_knot_vector_control REQUIRES K3D_BUILD_NGUI_KNOT_VECTOR_CONTROL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_learning REQUIRES K3D_BUILD_NGUI_LEARNING_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_log REQUIRES K3D_BUILD_NGUI_LOG_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_material_manager_panel REQUIRES K3D_BUILD_NGUI_MATERIAL_MANAGER_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_mesh_control REQUIRES K3D_BUILD_NGUI_MESH_CONTROL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui REQUIRES K3D_BUILD_NGUI_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_morph_points_page REQUIRES K3D_BUILD_NGUI_MORPH_POINTS_PAGE_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_node_list_panel REQUIRES K3D_BUILD_NGUI_NODE_LIST_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_node_properties_panel REQUIRES K3D_BUILD_NGUI_NODE_PROPERTIES_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_opengl_dialog REQUIRES K3D_BUILD_NGUI_OPENGL_DIALOG_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_parent_tool REQUIRES K3D_BUILD_NGUI_PARENT_TOOL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_pipeline_panel REQUIRES K3D_BUILD_NGUI_PIPELINE_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_pipeline_profiler_panel REQUIRES K3D_BUILD_NGUI_PIPELINE_PROFILER_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_python_shell REQUIRES K3D_BUILD_NGUI_PYTHON_SHELL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_rectangle_control REQUIRES K3D_BUILD_NGUI_RECTANGLE_CONTROL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_render_region_tool REQUIRES K3D_BUILD_NGUI_RENDER_REGION_TOOL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_selection_control REQUIRES K3D_BUILD_NGUI_SELECTION_CONTROL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_snap_tool REQUIRES K3D_BUILD_NGUI_SNAP_TOOL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_space_navigator REQUIRES K3D_BUILD_NGUI_SPACE_NAVIGATOR_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_text_editor REQUIRES K3D_BUILD_NGUI_TEXT_EDITOR_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_timeline_panel REQUIRES K3D_BUILD_NGUI_TIMELINE_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_toolbar_panel REQUIRES K3D_BUILD_NGUI_TOOLBAR_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_tool_properties_panel REQUIRES K3D_BUILD_NGUI_TOOL_PROPERTIES_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_undo_tree_panel REQUIRES K3D_BUILD_NGUI_UNDO_TREE_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(ngui_uv_editor_panel REQUIRES K3D_BUILD_NGUI_UV_EDITOR_PANEL_MODULE)
K3D_ADD_SUBDIRECTORY(nui REQUIRES K3D_BUILD_NUI_MODULE)
K3D_ADD_SUBDIRECTORY(nurbs REQUIRES K3D_BUILD_NURBS_MODULE)
K3D_ADD_SUBDIRECTORY(nurbs_sources REQUIRES K3D_BUILD_NURBS_SOURCES_MODULE)
K3D_ADD_SUBDIRECTORY(obj_io REQUIRES K3D_BUILD_OBJ_IO_MODULE)
K3D_ADD_SUBDIRECTORY(ode REQUIRES K3D_BUILD_ODE_MODULE)
K3D_ADD_SUBDIRECTORY(ogre_io REQUIRES K3D_BUILD_OGRE_IO_MODULE)
K3D_ADD_SUBDIRECTORY(opencascade REQUIRES K3D_BUILD_OPENCASCADE_MODULE)
K3D_ADD_SUBDIRECTORY(openexr_io REQUIRES K3D_BUILD_OPENEXR_IO_MODULE)
K3D_ADD_SUBDIRECTORY(opengl REQUIRES K3D_BUILD_OPENGL_MODULE)
K3D_ADD_SUBDIRECTORY(osmesa REQUIRES K3D_BUILD_OSMESA_MODULE)
K3D_ADD_SUBDIRECTORY(osx REQUIRES K3D_BUILD_OSX_MODULE)
K3D_ADD_SUBDIRECTORY(particle REQUIRES K3D_BUILD_PARTICLE_MODULE)
K3D_ADD_SUBDIRECTORY(pdiff REQUIRES K3D_BUILD_PDIFF_MODULE)
K3D_ADD_SUBDIRECTORY(pixie REQUIRES K3D_BUILD_PIXIE_MODULE)
K3D_ADD_SUBDIRECTORY(plot REQUIRES K3D_BUILD_PLOT_MODULE)
K3D_ADD_SUBDIRECTORY(ply_io REQUIRES K3D_BUILD_PLY_IO_MODULE)
K3D_ADD_SUBDIRECTORY(png_io REQUIRES K3D_BUILD_PNG_IO_MODULE)
K3D_ADD_SUBDIRECTORY(polyhedron REQUIRES K3D_BUILD_POLYHEDRON_MODULE)
K3D_ADD_SUBDIRECTORY(polyhedron_sources REQUIRES K3D_BUILD_POLYHEDRON_SOURCES_MODULE)
K3D_ADD_SUBDIRECTORY(python REQUIRES K3D_BUILD_PYTHON_MODULE)
K3D_ADD_SUBDIRECTORY(pyui REQUIRES K3D_BUILD_PYUI_MODULE)
K3D_ADD_SUBDIRECTORY(qslim REQUIRES K3D_BUILD_QSLIM_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_about_dialog REQUIRES K3D_BUILD_QTUI_ABOUT_DIALOG_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_aqsis_mode REQUIRES K3D_BUILD_QTUI_AQSIS_MODE_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_aqsis REQUIRES K3D_BUILD_QTUI_AQSIS_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_boolean REQUIRES K3D_BUILD_QTUI_BOOLEAN_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_color REQUIRES K3D_BUILD_QTUI_COLOR_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_default_mode REQUIRES K3D_BUILD_QTUI_DEFAULT_MODE_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_javascript_shell REQUIRES K3D_BUILD_QTUI_JAVASCRIPT_SHELL_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_log REQUIRES K3D_BUILD_QTUI_LOG_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_matrix REQUIRES K3D_BUILD_QTUI_MATRIX_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_move_mode REQUIRES K3D_BUILD_QTUI_MOVE_MODE_MODULE)
K3D_ADD_SUBDIRECTORY(qtui REQUIRES K3D_BUILD_QTUI_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_node_list REQUIRES K3D_BUILD_QTUI_NODE_LIST_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_node_properties REQUIRES K3D_BUILD_QTUI_NODE_PROPERTIES_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_opengl REQUIRES K3D_BUILD_QTUI_OPENGL_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_path REQUIRES K3D_BUILD_QTUI_PATH_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_programmable_mode REQUIRES K3D_BUILD_QTUI_PROGRAMMABLE_MODE_MODULE)
K3D_ADD_SUBDIRECTORY(qtui_string REQUIRES K3D_BUILD_QTUI_STRING_MODULE)

=== po/CMakeLists.txt ===
PROJECT(po)

FIND_PROGRAM(K3D_INTLTOOL_UPDATE intltool-update)

FIND_PROGRAM(K3D_XGETTEXT xgettext)

FIND_PROGRAM(K3D_MSGMERGE msgmerge)

FIND_PROGRAM(K3D_MSGFMT msgfmt)

MESSAGE(STATUS "generating i18n catalog")

SET(SKIP_FILES
	"^share/shaders/"
	)

SET(LOCALIZABLE_FILES "")
FILE(GLOB_RECURSE TEMP_FILES "${k3d_SOURCE_DIR}/*.h")
LIST(APPEND LOCALIZABLE_FILES ${TEMP_FILES})
FILE(GLOB_RECURSE TEMP_FILES "${k3d_SOURCE_DIR}/*.cpp")
LIST(APPEND LOCALIZABLE_FILES ${TEMP_FILES})
LIST(SORT LOCALIZABLE_FILES)

FILE(WRITE ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in "")
FOREACH(LOCALIZABLE_FILE ${LOCALIZABLE_FILES})
	FILE(RELATIVE_PATH RELATIVE_LOCALIZABLE_FILE ${k3d_SOURCE_DIR} ${LOCALIZABLE_FILE})

	SET(TEST_FILE 1)
	FOREACH(SKIP_FILE ${SKIP_FILES})
		IF(RELATIVE_LOCALIZABLE_FILE MATCHES "${SKIP_FILE}")
			SET(TEST_FILE 0)
			BREAK()
		ENDIF()
	ENDFOREACH()

	IF(TEST_FILE)
		FILE(APPEND ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in "${RELATIVE_LOCALIZABLE_FILE}\n")
	ENDIF()
ENDFOREACH()

MESSAGE(STATUS "  done")

ADD_CUSTOM_COMMAND(
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in
	COMMAND ${K3D_XGETTEXT} --files-from ${CMAKE_CURRENT_BINARY_DIR}/POTFILES.in --keyword=_ -o ${CMAKE_CURRENT_BINARY_DIR}/k3d.pot --copyright-holder="Timothy M. Shead" --msgid-bugs-address="k3d-development@lists.sourceforge.net" --no-wrap --no-location
	WORKING_DIRECTORY ${k3d_SOURCE_DIR}
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/k3d.pot
	)

SET(K3D_CATALOGS chef)
SET(K3D_CATALOG_TARGETS "")
FOREACH(catalog ${K3D_CATALOGS})
	ADD_CUSTOM_TARGET(nls-update-${catalog}.po
		DEPENDS ${po_SOURCE_DIR}/${catalog}.po
		COMMAND ${K3D_MSGMERGE} ${po_SOURCE_DIR}/${catalog}.po ${CMAKE_CURRENT_BINARY_DIR}/k3d.pot -o ${catalog}.po --no-wrap --sort-output
		WORKING_DIRECTORY ${po_SOURCE_DIR}
		)

	FILE(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES")

	ADD_CUSTOM_COMMAND(
		DEPENDS ${po_SOURCE_DIR}/${catalog}.po
		COMMAND ${K3D_MSGFMT} -c -o ${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES/k3d.mo ${po_SOURCE_DIR}/${catalog}.po
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES/k3d.mo
		)

	INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES/k3d.mo
		DESTINATION share/k3d/locale/${catalog}/LC_MESSAGES
		)

	LIST(APPEND K3D_CATALOG_TARGETS ${CMAKE_CURRENT_BINARY_DIR}/${catalog}/LC_MESSAGES/k3d.mo)
ENDFOREACH(catalog)

ADD_CUSTOM_TARGET(nls ALL
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/k3d.pot ${K3D_CATALOG_TARGETS}
	)

=== renderframe/CMakeLists.txt ===
PROJECT(renderframe)

INCLUDE_DIRECTORIES(
	${k3d_SOURCE_DIR}
	${k3dsdk_BINARY_DIR}
	${Boost_INCLUDE_DIRS}
	${K3D_GLIBMM_INCLUDE_DIRS}
	${K3D_SIGC_INCLUDE_DIRS}
	)

LINK_DIRECTORIES(
	${K3D_GLIBMM_LIB_DIRS}
	${K3D_SIGC_LIB_DIRS}
	)

IF(WIN32 AND K3D_COMPILER_GCC)
	# For some reason, building with optimizations enabled causes link problems with boost::regex and auto-import
	SET_SOURCE_FILES_PROPERTIES(main.cpp PROPERTIES COMPILE_FLAGS -O0)
ENDIF()

ADD_EXECUTABLE(k3d-renderframe
	main.cpp
	)

SET_TARGET_PROPERTIES(k3d-renderframe PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY ${K3D_RUNTIME_OUTPUT_DIRECTORY}
  )

TARGET_LINK_LIBRARIES(k3d-renderframe
	k3dsdk
	${Boost_REGEX_LIBRARY}
	)
IF(WIN32 AND K3D_COMPILER_GCC)
	SET_TARGET_PROPERTIES(k3d-renderframe PROPERTIES LINK_FLAGS -mwindows)
ENDIF()

INSTALL(TARGETS k3d-renderframe DESTINATION bin)

=== uuidgen/CMakeLists.txt ===
PROJECT(uuidgen)

INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})

LINK_DIRECTORIES(${K3D_GLIBMM_LIB_DIRS})
LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

ADD_EXECUTABLE(k3d-uuidgen
  main.cpp
  )

SET_TARGET_PROPERTIES(k3d-uuidgen PROPERTIES
  RUNTIME_OUTPUT_DIRECTORY ${K3D_RUNTIME_OUTPUT_DIRECTORY}
  )

TARGET_LINK_LIBRARIES(k3d-uuidgen
  k3dsdk
  )

INSTALL(TARGETS k3d-uuidgen DESTINATION bin)

=== docs/sample_module/CMakeLists.txt ===
K3D_BUILD_MODULE(sample-module)
K3D_CREATE_MODULE_PROXY(sample-module)

=== k3dsdk/Half/CMakeLists.txt ===
PROJECT(k3dsdk-half)

ADD_EXECUTABLE(eLut eLut.cpp)
GET_TARGET_PROPERTY(eLut_EXE eLut LOCATION)

ADD_EXECUTABLE(toFloat toFloat.cpp)
GET_TARGET_PROPERTY(toFloat_EXE toFloat LOCATION)

ADD_CUSTOM_COMMAND(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/eLut.h
	DEPENDS eLut
	COMMAND ${eLut_EXE} > ${CMAKE_CURRENT_BINARY_DIR}/eLut.h
	)

ADD_CUSTOM_COMMAND(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/toFloat.h
	DEPENDS toFloat
	COMMAND ${toFloat_EXE} > ${CMAKE_CURRENT_BINARY_DIR}/toFloat.h
	)

SET(SOURCES
	${CMAKE_CURRENT_BINARY_DIR}/eLut.h
	${CMAKE_CURRENT_BINARY_DIR}/toFloat.h
	half.cpp
	half.h
	halfFunction.h
	halfLimits.h
	)

INCLUDE_DIRECTORIES(${k3dsdk-half_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk-half_BINARY_DIR})

K3D_ADD_LIBRARY(k3dsdk-half SHARED ${SOURCES})
K3D_GENERATE_DEF_FILE(k3dsdk-half)

INSTALL(TARGETS k3dsdk-half
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${K3D_LIBDIR}
	ARCHIVE DESTINATION ${K3D_LIBDIR}
	)

=== k3dsdk/ngui/CMakeLists.txt ===
PROJECT(k3dsdk-ngui)

FILE(GLOB HEADERS *.h)
FILE(GLOB SOURCES *.cpp)

LIST(SORT HEADERS)
LIST(SORT SOURCES)

INCLUDE_DIRECTORIES(${k3d_SOURCE_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${k3dsdk_BINARY_DIR})
INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GLIBMM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GTKGLEXT_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_GTKMM_INCLUDE_DIRS})
INCLUDE_DIRECTORIES(${K3D_SIGC_INCLUDE_DIRS})

LINK_DIRECTORIES(${K3D_GTKGLEXT_LIB_DIRS})
LINK_DIRECTORIES(${K3D_GTKMM_LIB_DIRS})
LINK_DIRECTORIES(${K3D_SIGC_LIB_DIRS})

K3D_ADD_LIBRARY(k3dsdk-ngui SHARED ${HEADERS} ${SOURCES})
K3D_GENERATE_DEF_FILE(k3dsdk-ngui)

TARGET_LINK_LIBRARIES(k3dsdk-ngui k3dsdk)
TARGET_LINK_LIBRARIES(k3dsdk-ngui k3dsdk-opengl)
TARGET_LINK_LIBRARIES(k3dsdk-ngui ${K3D_GLIBMM_LIBS})
TARGET_LINK_LIBRARIES(k3dsdk-ngui ${K3D_GTKGLEXT_LIBS})
TARGET_LINK_LIBRARIES(k3dsdk-ngui ${K3D_GTKMM_LIBS})

IF(K3D_ENABLE_NLS)
	INCLUDE_DIRECTORIES(${K3D_INTL_INCLUDE_DIRS})
	TARGET_LINK_LIBRARIES(k3dsdk-ngui ${K3D_INTL_LIBS})
ENDIF(K3D_ENABLE_NLS)

INSTALL(TARGETS k3dsdk-ngui
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${K3D_LIBDIR}
	ARCHIVE DESTINATION ${K3D_LIBDIR})

=== k3dsdk/parallel/CMakeLists.txt ===
PROJECT(k3dsdk-parallel)

FILE(GLOB HEADERS *.h)
FILE(GLOB SOURCES *.cpp)

LIST(SORT HEADERS)
LIST(SORT SOURCES)

K3D_ADD_LIBRARY(k3dsdk-parallel SHARED ${HEADERS} ${SOURCES})
K3D_GENERATE_DEF_FILE(k3dsdk-parallel)

IF(K3D_ENABLE_PARALLEL)
	INCLUDE_DIRECTORIES(${K3D_TBB_INCLUDE_DIR})
	TARGET_LINK_LIBRARIES(k3dsdk-parallel ${K3D_TBB_LIBRARY})
ENDIF(K3D_ENABLE_PARALLEL)

INSTALL(TARGETS k3dsdk-parallel
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${K3D_LIBDIR}
	ARCHIVE DESTINATION ${K3D_LIBDIR})
INSTALL(FILES ${HEADERS} DESTINATION include/k3d/k3dsdk/parallel)

=== k3dsdk/resource/CMakeLists.txt ===
PROJECT(k3dsdk-resource)

FILE(GLOB HEADERS *.h)
FILE(GLOB SOURCES *.cpp)

LIST(SORT HEADERS)
LIST(SORT SOURCES)

K3D_ADD_LIBRARY(k3dsdk-resource SHARED ${HEADERS} ${SOURCES})
K3D_GENERATE_DEF_FILE(k3dsdk-resource)

TARGET_LINK_LIBRARIES(k3dsdk-resource k3dsdk)

INSTALL(TARGETS k3dsdk-resource
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${K3D_LIBDIR}
	ARCHIVE DESTINATION ${K3D_LIBDIR})
INSTALL(FILES ${HEADERS} DESTINATION include/k3d/k3dsdk/resource)

=== k3dsdk/sgi_tesselator/CMakeLists.txt ===
PROJECT(k3dsdk-sgi-tesselator)

FILE(GLOB HEADERS *.h)
SET(SOURCES
	dict.c
	dict.h
	dict-list.h
	geom.c
	geom.h
	gluos.h
	memalloc.c
	memalloc.h
	mesh.c
	mesh.h
	normal.c
	normal.h
	priorityq.c
	priorityq-heap.h
	priorityq-sort.h
	render.c
	render.h
	sweep.c
	sweep.h
	tess.c
	tess.h
	tessmono.c
	tessmono.h
	)

SET_SOURCE_FILES_PROPERTIES(
	dict.c
	geom.c
	memalloc.c
	priorityq.c
	render.c
	tess.c
	PROPERTIES COMPILE_FLAGS -w
	)

K3D_ADD_LIBRARY(k3dsdk-sgi-tesselator SHARED ${SOURCES})
K3D_GENERATE_DEF_FILE(k3dsdk-sgi-tesselator)

INSTALL(TARGETS k3dsdk-sgi-tesselator
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION ${K3D_LIBDIR}
	ARCHIVE DESTINATION ${K3D_LIBDIR})

=== debian/changelog ===
k3d (0.8.0.3-3build1) trusty; urgency=medium

  * No change rebuild against glew 1.10.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 02 Jan 2014 13:22:06 +0000

k3d (0.8.0.3-3) unstable; urgency=low

  * Upload again to rebuild against newer versions of libraries, in particular
    Boost
  * Small updates for lintian issues

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Sat, 07 Sep 2013 19:56:51 +0100

k3d (0.8.0.3-2) unstable; urgency=low

  * Setting a special $HOME in debian/rules, necessary to build the guide
  * Moving guide to /usr/share/doc, keeping a symbolic link to be accessible
    from the GUI

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Tue, 23 Jul 2013 19:13:15 +0100

k3d (0.8.0.3-1) unstable; urgency=low

  * New upstream version
  * Disable patches (incorporated upstream):
    - bug_554930-ftbfs-gold.patch
    - disable_mutable_in_boost_gil.patch
    - k3d_gtkmm224.patch
    - ftbfs-gcc47.patch
  * Removed k3d.desktop (incorporated upstream)
  * Add build dependency on libftgl-dev, libglew-dev and libglewmx-dev, now that
    upstream added support for these external libraries instead of using bundled
    copies
  * Add asciidoc, xsltproc and libxml2-utils to build-depends to build
    documentation, and docbook-xml and -xsl to avoid fetching files from network
    at building time

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Tue, 23 Jul 2013 13:02:43 +0100

k3d (0.8.0.2-20) unstable; urgency=low

  * Disable cgal dependency on armel (Closes: #713069), thanks Adam D. Barratt
    for reporting and Joachim Reichel for support.

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 26 Jun 2013 18:21:42 +0100

k3d (0.8.0.2-19) unstable; urgency=low

  * Enable CGAL module by build-depending on libcgal-dev (>= 4.0), now in main
    (it was in non-free before)
  * debian/control:
    - Bump Standards-Version to 3.9.4 (no changes needed)
    - Remove "DM-Upload-Allowed: yes" (obsolete field now)
    - Replace Maintainer address, not active for many years
    - Add Vcs-* fields

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Mon, 01 Apr 2013 00:39:27 +0100

k3d (0.8.0.2-18) unstable; urgency=low

  * Build-Depend on libtiff-dev after all, since it seems that using
    libtiff5-dev in wheezy is discouraged, and the build-depends were causing
    loops in buildds when trying to resolve dependencies (Closes: #676786).
    Thanks Aurelien Jarno and Julien Cristau for the report and the advice.

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 10 Jun 2012 16:40:49 +0100

k3d (0.8.0.2-17) unstable; urgency=low

  * Fix dependency on ttf-bitstream-vera, the data package was symlinking to
    files contained in it without depending on it
  * Build-depend on (libtiff5-dev | libtiff4-dev) (instead of only version 4)
  * Move lintian override no-upstream-changelog from source to binary packages,
    it doesn't belong in sources

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Fri, 08 Jun 2012 16:08:20 +0100

k3d (0.8.0.2-16) unstable; urgency=low

  * Bump Policy Standards-Version to 3.9.3 (no changes needed)
  * Update Build-Depends debhelper to >=9~ instead of 8.9.0~ (quells lintian
    warning package-needs-versioned-debhelper-build-depends)
  * Move lintian override no-upstream-changelog from k3d binary package to
    source
  * Add patch ftbfs-gcc47.patch to fix a FTBFS with GCC-4.7 (Closes: #672627)

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Tue, 05 Jun 2012 12:12:53 +0100

k3d (0.8.0.2-15) unstable; urgency=low

  * Switch to debhelper compat level v9
  * Enable some extra compiling options and hardening flags

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Wed, 21 Dec 2011 13:55:24 +0000

k3d (0.8.0.2-14) unstable; urgency=low

  * Not modifying CXXFLAGS or anything related with DEB_BUILD_OPTIONS, removing
    from 'rules'

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Mon, 14 Nov 2011 20:14:05 +0000

k3d (0.8.0.2-13) unstable; urgency=low

  * Fix FTBFS when providing more than one element in CXXFLAGS
    (Closes: #646274), thanks Julian Taylor for reporting
  * Removed Vcs-Hg and Vcs-Browser in "control" file, they point to
    upstream and not the Debian packaging
  * Quell lintian:
    - desktop-entry-contains-encoding-key: Removed Encoding line from
      k3d.desktop, it's unnecessary/deprecated
    - unneeded-build-dep-on-quilt: Removed Build-Depends on quilt
    - no-upstream-changelog: Upstream doesn't provide any, override
      lintian warning
    - no-symbols-control-file: the dynamic objects in this package are
      not used as a shared library, but as internal program
      addons/plugins, they don't need versioning, override lintian
      warning

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sat, 22 Oct 2011 23:03:35 +0100

k3d (0.8.0.2-12) unstable; urgency=low

  * Remove from debian/rules the special handling of "CXXFLAGS +=
  -ffunction-sections -mlong-calls" for HPPA architecture, for several reasons:
  it never really worked, HPPA is in debian-ports now (so lesser importance),
  k3d is not a suitable package for HPPA machines anyway (it's for modern
  desktops), and it hasn't been installable for a while (due to important
  missing dependencies, such as cmake).

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Mon, 22 Aug 2011 16:06:07 +0100

k3d (0.8.0.2-11) unstable; urgency=low

  * Remove "Build-Depends libinotifytools-dev [linux-any]", it's not needed
    really -- only <sys/inotify.h> is needed
  * Modify debian/rules to include "/usr/include/MULTIARCH_DIR" when searching
    for inotify, otherwise the simple method to search for the availability of
    the library does not work.

 -- Manuel A. Fernandez Montecelo <manuel.montezelo@gmail.com>  Sun, 21 Aug 2011 13:38:58 +0100

k3d (0.8.0.2-10) unstable; urgency=low

  * Using "Build-Depends libinotifytools-dev [linux-any]", instead of excluding


=== debian/control ===
Source: k3d
Section: graphics
Priority: extra
Standards-Version: 3.9.4
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Manuel A. Fernandez Montecelo <mafm@debian.org>
Homepage: http://www.k-3d.org/
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/k3d.git
Vcs-Git: git://anonscm.debian.org/collab-maint/k3d.git
Build-Depends: debhelper (>= 9~),
               cmake (>> 2.6),
               pkg-config,
               asciidoc,
               libxml2-utils,
               xsltproc,
               docbook-xml,
               docbook-xsl,
               zlib1g-dev,
               uuid-dev,
               libsigc++-2.0-dev,
               libglibmm-2.4-dev,
               libgtkmm-2.4-dev,
               libgnomevfs2-dev,
               libgtksourceview2.0-dev,
               libgtkglext1-dev,
               libcairomm-1.0-dev,
               libdbus-glib-1-dev,
               libxml2-dev | libexpat1-dev,
               libfreetype6-dev,
               libboost-dev (>= 1.42),
               libboost-date-time-dev (>= 1.42),
               libboost-regex-dev (>= 1.42),
               libboost-program-options-dev (>= 1.42),
               libboost-test-dev (>= 1.42),
               libboost-python-dev (>= 1.42),
               libcgal-dev (>= 4.0) [!armel],
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libftgl-dev,
               libglew-dev,
               libglewmx-dev,
               libpng-dev,
               librsvg2-dev,
               libjpeg-dev,
               libopenexr-dev,
               libtiff-dev,
               libmagick++-dev,
               lib3ds-dev,
               libgts-dev,
               python-dev,
               python-support,
               graphviz,
               libsuperlu3-dev,
               libode-dev,
               gettext


Package: k3d
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         k3d-data (= ${source:Version})
Replaces: k3d-dev (<< 0.8.0.1)
Breaks: k3d-dev (<< 0.8.0.1)
Description: 3D modeling and animation system, binary files
 K-3D is free-as-in-freedom 3D modeling and animation software. It combines
 flexible plugins with a visualization pipeline architecture, making K-3D a
 versatile and powerful tool for artists.
 .
 This package contains binaries and libraries.

Package: k3d-data
Architecture: all
Replaces: k3d (<< 0.8.0.2-2)
Breaks: k3d (<< 0.8.0.2-2)
Depends: ${misc:Depends},
         ttf-bitstream-vera (>= 1.10)
Description: 3D modeling and animation system, data files
 K-3D is free-as-in-freedom 3D modeling and animation software. It combines
 flexible plugins with a visualization pipeline architecture, making K-3D a
 versatile and powerful tool for artists.
 .
 This package contains data needed by the binaries (shaders, GUI elements, ...).

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# needed for CGAL, otherwise fails compiling with:
# Explanation: Wrong rounding: did you forget the  -frounding-math  option if you use GCC (or  -fp-model strict  for Intel)?
CGAL_COMPILER_FLAG := -frounding-math

export DEB_BUILD_MAINT_OPTIONS   := hardening=+pie,+bindnow
export DEB_CFLAGS_MAINT_APPEND   := -pipe -Wall $(shell dpkg-buildflags --get CPPFLAGS) $(CGAL_COMPILER_FLAG)
export DEB_CXXFLAGS_MAINT_APPEND := -pipe -Wall $(shell dpkg-buildflags --get CPPFLAGS) $(CGAL_COMPILER_FLAG)
export DEB_LDFLAGS_MAINT_APPEND  := -Wl,-z,defs -Wl,--as-needed


# inotify in multiarch system -- K3DFindInotify.cmake script tries to
# find 'sys/inotify.h' under '/usr/include' exclusively, by default, so
# it fails to find and thus disables building of the k3d-inotify.module
ifeq (linux,$(DEB_BUILD_ARCH_OS))
	CMAKE_INOTIFY += -DK3D_INOTIFY_INCLUDE_DIR="/usr/include/$(DEB_BUILD_MULTIARCH)"
endif


# Setting $HOME, needed to build the guide (otherwise it fails in Debian
# buildds, where $HOME cannot be used)
BUILD_HOME = $(CURDIR)/debian/build_home


%:
	dh $@ --buildsystem=cmake --parallel

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_INOTIFY)

override_dh_auto_build:
	mkdir -p $(BUILD_HOME)
	HOME=$(BUILD_HOME) dh_auto_build

override_dh_auto_install:
	dh_auto_install

        # Strip plugins and libraries, dh_link doesn't work with all of them
	find debian/tmp/usr/lib -name \*.module -exec strip --strip-unneeded --remove-section=.comment --remove-section=.note {} \;

        # Remove files, we're not going to ship them because it would be only
        # useful for plugin developers and upstream discourages it
	rm -fr debian/tmp/usr/include debian/tmp/usr/lib/k3d/include
	rm -f debian/tmp/usr/lib/*.so

        # Remove qtui data files, qtui is not built
	rm -fr debian/tmp/usr/share/k3d/qtui

        # Move guide
	mkdir -p debian/tmp/usr/share/doc/k3d
	mv debian/tmp/usr/share/k3d/guide debian/tmp/usr/share/doc/k3d

        # Quell lintian warning "duplicate-font-file" by removing the files and
        # symlinking to the ones in the package tff-bitstream-vera.  Use
        # dh_link, since paths must be relative when elements in the path are
        # common (e.g. /usr/)
	rm -f debian/tmp/usr/share/k3d/fonts/Vera*.ttf

override_dh_install:
	dh_install --list-missing

override_dh_shlibdeps:
	dh_shlibdeps -- debian/k3d/usr/lib/k3d/plugins/*.module

override_dh_clean:
	dh_clean
	rm -rf $(BUILD_HOME)

=== debian/watch ===
version=3
#http://sf.net/k3d/k3d-source-(.*)\.tar\.bz2
#http://githubredir.debian.net/github/K-3D/k3d/k3d-(.*).tar.gz
https://github.com/K-3D/k3d/tags .*/k3d-v?(\d\S*)\.tar\.gz
